"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRenderingIndex = void 0;
function getRenderingIndex(
// eslint-disable-next-line @typescript-eslint/no-explicit-any
theObject, uid, componentName, index) {
    let result = null;
    if (theObject instanceof Array) {
        const filteredList = [];
        for (const placeholder of theObject) {
            // Exclude experience editor placeholders from the list
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            const ph = placeholder;
            if (ph.name != 'code') {
                filteredList.push(placeholder);
            }
        }
        for (let i = 0; i < filteredList.length; i++) {
            result = getRenderingIndex(filteredList[i], uid, componentName, i);
            if (result != null)
                return result;
        }
    }
    else {
        for (const prop in theObject) {
            if (prop == 'uid' && theObject['componentName'] == componentName) {
                if (theObject[prop] == uid) {
                    return { rendering: theObject, index: index !== null && index !== void 0 ? index : 0 };
                }
            }
            if (theObject[prop] instanceof Object || theObject[prop] instanceof Array)
                result = getRenderingIndex(theObject[prop], uid, componentName);
            if (result != null)
                return result;
        }
    }
    return result;
}
exports.getRenderingIndex = getRenderingIndex;
