"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withDatasourceRendering = void 0;
const sitecore_jss_nextjs_1 = require("@sitecore-jss/sitecore-jss-nextjs");
const react_1 = __importDefault(require("react"));
function withDatasourceRendering() {
    return function withDatasourceRenderingHoc(componentOrMap) {
        return function WithDatasourceRendering(props) {
            var _a, _b, _c, _d;
            const { sitecoreContext } = (0, sitecore_jss_nextjs_1.useSitecoreContext)();
            const siteName = (_b = (_a = sitecoreContext.site) === null || _a === void 0 ? void 0 : _a.name) !== null && _b !== void 0 ? _b : 'default';
            let InjectedComponent;
            if (typeof componentOrMap === 'function') {
                InjectedComponent = componentOrMap;
            }
            else {
                InjectedComponent = (_c = componentOrMap[siteName]) !== null && _c !== void 0 ? _c : componentOrMap['default'];
            }
            if (!props.rendering.dataSource) {
                return react_1.default.createElement(InjectedComponent, Object.assign({}, props, { fields: (_d = sitecoreContext.route) === null || _d === void 0 ? void 0 : _d.fields }));
            }
            return react_1.default.createElement(InjectedComponent, Object.assign({}, props));
        };
    };
}
exports.withDatasourceRendering = withDatasourceRendering;
